
#include "APO.h"
#include <string.h>
#define ngrids 4
#define ndec 3

APO vapo[ngrids*ndec];
Grid vgrid[ngrids];
Obs vobs[ndec];
Transf vtransf[ndec];
Instrume alma;

Site Chaj;
Model mod1;

void APOf(char *namei, char *nameo);

/*==========================================*/


void main(){

  int i;
  char s[15];
  char namei[40], nameo[40];

  printf("----Start of main------ \n");
  //sprintf(namei,"%s","config/multi1/m83_8_s_0.data");
  //sprintf(nameo,"%s","config/multi1/m83_8_s_0out.data ");
  //sprintf(namei,"%s","config/multi1/p37_8_s_0.data");
  //sprintf(nameo,"%s","config/multi1/p37_8_s_0out.data ");
  //sprintf(namei,"%s","config/g0.data");
  //sprintf(nameo,"%s","config/g0out.data");
  //sprintf(namei,"%s","config/cpct60.data");
  //sprintf(nameo,"%s","config/cpct60out.data");
  //APOf(namei, nameo);
  //sprintf(namei,"%s","config/cpct60out.data");
  //sprintf(nameo,"%s","config/cpct60out.data");
  //APOf(namei, nameo);
  //sprintf(namei,"%s","config/cpcth60.data");
  //sprintf(nameo,"%s","config/cpcth60out.data");
  //APOf(namei, nameo);
  //sprintf(namei,"%s","config/cpcth60out.data");
  //sprintf(nameo,"%s","config/cpcth60out.data");
  //APOf(namei, nameo);
  //sprintf(namei,"%s","config/cpct60im.data");
  //sprintf(nameo,"%s","config/cpct60imout.data");
  //APOf(namei, nameo);
  //sprintf(namei,"%s","config/cpct60imout.data");
  //sprintf(nameo,"%s","config/cpct60imout.data");
  //APOf(namei, nameo);
  //sprintf(namei,"%s","config/cpcth60im.data");
  //sprintf(nameo,"%s","config/cpcth60imout.data");
  //APOf(namei, nameo);
  sprintf(namei,"%s","config/cpcth30sh.data");
  //sprintf(namei,"%s","config/cpcthmdecout.data");
  sprintf(nameo,"%s","config/cpcthmdecout.data");
  APOf(namei, nameo);
  printf("----End of main------ \n");
}




/*==========================================*/

void APOf(char *namei, char *nameo){
 

  Configfile filei, fileo;
  int i,j,k,l,iter,niter, natot;
  int test1,test2;
  char pause;
  float fa0,fa,gsh,dptacc;
  float gridrmax, gridrmin, gridsz0,dmax,fwhm,dec0;
  char *stdname="stdev.data";
  time_t rtime;
  FILE *fp;
  float stdev,integr;
  // int ngrids=7;

  rtime=time(NULL);
  if((fp=fopen(stdname,"w")) == NULL){
    printf("ERROR: cannot open file %s\n",stdname);
    exit(1);
  }
  filei=namei;
  fileo=nameo;
  filei.read(&alma, &Chaj, vobs, &mod1);
  //scanf("%c",&pause);
  //alma.print();
  //Chaj.print();

  fa0=0.00002;
  gsh=-1e10*fa0;
  dec0=-83.;

  natot=alma.getnatot();
  gridrmax=mod1.getdmax();
  gridrmin=mod1.getdmin();
  dmax=alma.getdmax();

  printf("gridrmax=%f\n",gridrmax);
  fwhm=mod1.getfwhm()/dmax;
  printf("fwhm=%f\n",fwhm);

  if(fwhm>1){
    if(fwhm<1.8) fa0/=(5*(pow(fwhm,1.4)-0.8));
    else fa0/=(5*(pow(1.8,1.4)-0.8));
  }
  printf("fa0=%f\n",fa0);
  dptacc=0.1; 
   gridsz0=7;
  for(i=0;i<ngrids;i++){
    vgrid[i].set(gridsz0+2*i, gridrmin,gridrmax, &mod1);
    printf("grid %d set\n",i);
  }
  vobs[0].set(dec0);
  for(i=1;i<ndec;i++){
    vobs[i]=vobs[0];
    vobs[i].set(dec0+i*30);
    printf("obs %d set\n",i);
  }
  for(i=0;i<ngrids;i++){
    for(j=0;j<ndec;j++){
      vapo[j*ngrids+i].set(&alma, vobs+j, vtransf+j, &Chaj, vgrid+i);
    }
  }
  vobs[0].print();
  scanf("%c",&pause);
  
  //transf1.setshadow(-73.);

  //vapo[0].correct(dptacc);
  correct(vapo,ngrids*ndec,dptacc);
  //for(i=0;i<ngrids;i++) vapo[i].set(&alma, &obs1, &transf1, &Chaj, vgrid+i);
  //fileo.write(&alma, &Chaj, &obs1, &mod1);

  scanf("%c",&pause);
  for(i=0;i<ngrids;i++) {
    stdev=vapo[i].getstdev();
    fprintf(fp,"%-9.2f ",stdev);
  }
  fprintf(fp,"\n");
  niter=20;
  for(k=0;k<niter;k++) {
    printf("k=%d\n",k);
    if(k==0) fa=fa0;
    else fa=3*fa0;
    if(k>2) fa=7*fa0;
    if(k>10) fa=5*fa0;
    //    if(k>niter-5) fa=5*fa0;
    if(k>niter-3) fa=3*fa0;
    fa=fa0;
    optimize_shad(vapo,ngrids*ndec,fa,dptacc,gsh);
    if(k<niter-3) shake(vapo,ngrids*ndec,dptacc);

    for(i=0;i<ngrids;i++) {
      stdev=vapo[i].getstdev();
      fprintf(fp,"%-9.2f ",stdev);
    }
    fprintf(fp,"\n");
  }
  fileo.write(&alma, &Chaj,vobs, &mod1);
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
  fclose(fp);
}

