
#include "APO.h"
#include <string.h>
#define ngrids 7
APO vapo[ngrids];

/*==========================================*/


void main(){
 
  Instrume alma;
  Obs obs1;
  Transf transf1;
  Site Chaj;
  Grid vgrid[ngrids];
  Model mod1;
  Configfile filei, fileo;
  int i,j,k,l, natot;
  int test1,test2;
  char pause;
  float fa0,dptacc;
  float gridrmax, gridrmin, gridsz0;
  char *namei="config/g30.data",*nameo="config/g30out.data";
  time_t rtime;

  rtime=time(NULL);

  filei=namei;
  fileo=nameo;

  filei.read(&alma, &Chaj, &obs1, &mod1);
  //scanf("%c",&pause);
  alma.print();
  Chaj.print();

  natot=alma.getnatot();
  gridrmax=alma.getdmax();
  printf("gridrmax=%f\n",gridrmax);
  dptacc=0.5; fa0=0.07; 
  gridrmin=12.; gridsz0=5;

  vgrid[0].set(gridsz0, gridrmin,gridrmax, &mod1);
  vapo[0].set(&alma, &obs1, &transf1, &Chaj, vgrid);

  vapo[0].printforce(0,fa0,"config/force.data");
  vgrid[0].print("config/grid.data");

  optimize(vapo,1,fa0,dptacc);


  fileo.write(&alma, &Chaj, &obs1, &mod1);
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
  printf("forces written in %s\n","config/force.data");
 
}

/*==========================================*/

