
#include "APO.h"
#include <string.h>
#define ngrids 7

APO vapo[ngrids];


void APOf(char *namei, char *nameo);

/*==========================================*/


void main(){

  int idec,idha,iha0,in,iha0max;
  int idec0,idha0,iha00,in0;
  char s[15],s2[5];
  char *sdec[5]={"m83","m53","m23","p07","p37"};
  char *sdha[4]={"_8","_4","_2","_0"};
  char *sha0[2]={"_s","_a"};
  char *sn[10]={"_0","_1","_2","_3","_4","_5","_6","_7","_8","_9"};
  char namei[40], nameo[40], *dir1="config/multi1/", *dir2="config/multi1/";
  FILE *fp;  
  time_t now;


  printf("----Start multioptimize------ \n");

  idec0=2;
  idha0=3;
  iha00=1;
  in0=0;

  for(idec=idec0;idec<5;idec++){
    for(idha=idha0;idha<4;idha++){
      if(idha==0) iha0max=1;
      else iha0max=2;
      for(iha0=iha00;iha0<iha0max;iha0++){
	for(in=in0;in<10;in++){
	  sprintf(namei,"%s%s%s%s%s",
		  dir1,sdec[idec],sdha[idha],sha0[iha0],sn[in]);
	  sprintf(nameo,"%s%s%s%s%s",
		  dir2,sdec[idec],sdha[idha],sha0[iha0],sn[in]);
	  strcat(namei,".data");
	  strcat(nameo,"out.data");
	  printf("namei=%s nameo=%s\n",namei,nameo); 

	  if((fp=fopen("apolog","a")) == NULL){
	    printf("ERROR: cannot open file %s\n","apolog");
	    exit(1);
	  }
	  now=time(NULL);
	  fprintf(fp," namei=%s %s \n",namei,ctime(&now));
	  fclose(fp);

	  APOf(namei, nameo);
	}
      }
    }
  }
  printf("----End of main------ \n");
}

/*==========================================*/

void APOf(char *namei, char *nameo){
 

  Instrume alma;
  Obs obs1;
  Transf transf1;
  Site Chaj;
  Grid vgrid[ngrids];
  Model mod1;
  Configfile filei, fileo;
  int i,j,k,l,iter,niter, natot;
  int test1,test2;
  char pause;
  float fa0,fa,dptacc,fwhm;
  float gridrmax, gridrmin, gridsz0;
  time_t rtime;
 
  // int ngrids=7;

  rtime=time(NULL);
  filei=namei;
  fileo=nameo;

  filei.read(&alma, &Chaj, &obs1, &mod1);
  //scanf("%c",&pause);
  alma.print();
  Chaj.print();

  natot=alma.getnatot();
  gridrmax=alma.getdmax();
  fwhm=mod1.getfwhm()/gridrmax;
  //fwhm*=40;
  //mod1.setfwhm(fwhm*gridrmax);
  printf("gridrmax=%f\n",gridrmax);
  printf("fwhm=%f\n",fwhm);
  fa0=0.003;
  if(fwhm>1){
    if(fwhm<1.8) fa0/=(5*(pow(fwhm,1.4)-0.8));
    else fa0/=(5*(pow(1.8,1.4)-0.8));
  }
  printf("fa0=%f\n",fa0);
  // scanf("%c",&pause);
  dptacc=0.5;   niter=4;
  gridrmin=15.; gridsz0=6;
  for(i=0;i<ngrids;i++){
    vgrid[i].set(gridsz0+i, gridrmin,gridrmax, &mod1);
    //    vgrid[i].print();
    vapo[i].set(&alma, &obs1, &transf1,&Chaj, vgrid+i);
  }
  correct(vapo,ngrids,dptacc);
  niter=20;
  for(k=0;k<niter;k++) {
    printf("k=%d\n",k);
    if(k==0) fa=fa0;
    else fa=3*fa0;
    if(k>2) fa=7*fa0;
    if(k>10) fa=5*fa0;
    //    if(k>niter-5) fa=5*fa0;
    if(k>niter-3) fa=3*fa0;
    optimize(vapo,ngrids,fa,dptacc);
    if(k<niter-3) shake(vapo,ngrids,dptacc);
  }
  fileo.write(&alma, &Chaj, &obs1, &mod1);
  rtime=time(NULL)-rtime;
  printf("total runing time= %ld sec\n",rtime);
}


/*==========================================*/

