pro readdata,na,nconf,ncom,nvisi,lat0,opac,dec,vha0,vintime,dha, $
        vdmax,tol,dmaxmod,diam, vdmin,$
        dminmod,radmask,radmin,dptmax, $
        mapname,map,dxa,dya,nxm,nym,xc,yc,width,plotonmap, $
        xx,yy,fixedant,datafile

ans=''
line=''
vline='!'
mapname=''
print,'reading parameters in ',datafile
openr,1,datafile
while vline(0) eq '!' do begin
  readf,1,line
  print,line
  vline=str_sep(line,' ')
endwhile

na=long(vline(0))
readf,1,nconf
readf,1,ncom
readf,1,nvisi
print,'nvisi=',nvisi
readf,1,lat0
readf,1,opac
readf,1,dec
readf,1,line
line=strcompress(line)
vline=str_sep(line,' ')
vha0=fltarr(nconf)
for i=0,nconf-1 do vha0(i)=float(vline(i))
readf,1,line
line=strcompress(line)
vline=str_sep(line,' ')
vintime=fltarr(nconf)
for i=0,nconf-1 do vintime(i)=float(vline(i))
readf,1,dha
readf,1,line
line=strcompress(line)
vline=str_sep(line,' ')
vdmax=fltarr(nconf)
for i=0,nconf-1 do vdmax(i)=float(vline(i))
readf,1,tol
readf,1,dmaxmod
readf,1,diam
readf,1,dspec
readf,1,line
line=strcompress(line)
vline=str_sep(line,' ')
vdmin=fltarr(nconf)
for i=0,nconf-1 do vdmin(i)=float(vline(i))
readf,1,dminmod
readf,1,radmask
readf,1,radmin
readf,1,dptmax
readf,1,mapname
readf,1,dxa
readf,1,dya
readf,1,xc
readf,1,yc
readf,1,width
readf,1,plotonmap

dec=dec*!pi/180.
lat0=lat0*!pi/180.
dmax=max(vdmax)
mapname=(str_sep(mapname,' '))(0)
print,'read site map: ',mapname
map=readfits(mapname)
nxm=(size(map))(1) & nym=(size(map))(2)
natot=nconf*na-ncom*(nconf-1)
xx=fltarr(natot)
yy=fltarr(natot)

fixedant=intarr(natot)
a=0.
for i=0,natot-1 do begin
   readf,1,a,b,c
   xx(i)=a & yy(i)=b
   fixedant(i)=c
endfor
close,1


end
